Index: drivers/char/sb1250_duart.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/sb1250_duart.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/sb1250_duart.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/sb1250_duart.c	4 Aug 2004 01:28:45 -0000	1.2
@@ -721,69 +837,87 @@
 	if (ret) {
 		printk(KERN_ERR "Unable to unregister sb1250 duart serial driver (%d)\n", ret);
 	}
-	free_irq(K_INT_UART_0, &uart_states[0]);
-	free_irq(K_INT_UART_1, &uart_states[1]);
-
-	/* mask lines in the scd */
-	disable_irq(K_INT_UART_0);
-	disable_irq(K_INT_UART_1);
-
+	for (i=0; i<DUART_MAX_LINE; i++) {
+		if (!sb1250_duart_present[i])
+			continue;
+		free_irq(K_INT_UART_0+i, &uart_states[i]);
+		disable_irq(K_INT_UART_0+i);
+	}
 	restore_flags(flags);
 }
 
 module_init(sb1250_duart_init);
 module_exit(sb1250_duart_fini);
 MODULE_DESCRIPTION("SB1250 Duart serial driver");
-MODULE_AUTHOR("Justin Carlson <carlson@sibyte.com>");
+MODULE_AUTHOR("Justin Carlson, Broadcom Corp.");
 
-#ifdef CONFIG_SERIAL_CONSOLE
+#ifdef CONFIG_SIBYTE_SB1250_DUART_CONSOLE
 
 /*
- * Serial console stuff. 
- * Very basic, polling driver for doing serial console output. 
- * FIXME; there is a race here; we can't be sure that
- * the tx is still empty without holding outp_lock for this line.
- * Worst that can happen for now, though, is dropped characters.
+ * Serial console stuff.  Very basic, polling driver for doing serial
+ * console output.  The console_sem is held by the caller, so we
+ * shouldn't be interrupted for more console activity.
+ * XXXKW What about getting interrupted by uart driver activity?
  */
 
-static void ser_console_write(struct console *cons, const char *str,
-                              unsigned int count)
+void serial_outc(unsigned char c, int line)
 {
-	unsigned int i;
-	unsigned long flags;
-	spin_lock_irqsave(&uart_states[0].outp_lock, flags);
-
-	for (i = 0; i < count; i++) {
-                if (str[i] == '\n') {
-                        /* Expand LF -> CRLF */
-                        while (!(get_status_reg(0) & M_DUART_TX_RDY)) {
-                                /* Spin, doing nothing.  */
-                        }
-			out64('\r', IO_SPACE_BASE | A_DUART_CHANREG(0, R_DUART_TX_HOLD));
-                }
-		while (!(get_status_reg(0) & M_DUART_TX_RDY)) {
-			/* Spin, doing nothing.  */
-		}
-		out64(str[i], IO_SPACE_BASE | A_DUART_CHANREG(0, R_DUART_TX_HOLD));
-	}
-	spin_unlock_irqrestore(&uart_states[0].outp_lock, flags);
+	uart_state_t *port = uart_states + line;
+	while (!(READ_SERCSR(port->status, line) & M_DUART_TX_RDY)) ;
+	WRITE_SERCSR(c, port->tx_hold, line);
+	while (!(READ_SERCSR(port->status, port->line) & M_DUART_TX_EMT)) ;
+}
+
+static void ser_console_write(struct console *cons, const char *s,
+	unsigned int count)
+{
+	int line = cons->index;
+	uart_state_t *port = uart_states + line;
+	u32 imr;
+
+	imr = READ_SERCSR(port->imr, line);
+	WRITE_SERCSR(0, port->imr, line);
+	while (count--) {
+		if (*s == '\n')
+			serial_outc('\r', line);
+		serial_outc(*s++, line);
+    	}
+	WRITE_SERCSR(imr, port->imr, line);
 }
 
 static kdev_t ser_console_device(struct console *c)
 {
-	return MKDEV(TTY_MAJOR, 64 + c->index);
+	return MKDEV(TTY_MAJOR, SB1250_DUART_MINOR_BASE + c->index);
 }
 
 static int ser_console_setup(struct console *cons, char *str)
 {
-	/* Initialize the transmitter */
-	
-	duart_set_cflag(0, DEFAULT_CFLAGS);
+	int i;
+
+	for (i=0; i<DUART_MAX_LINE; i++) {
+		uart_state_t *port = uart_states + i;
+
+		if (!sb1250_duart_present[i])
+			continue;
+
+		init_duart_port(port, i);
+#if SIBYTE_1956_WAR
+		last_mode1[i] = V_DUART_PARITY_MODE_NONE|V_DUART_BITS_PER_CHAR_8;
+#endif
+		WRITE_SERCSR(V_DUART_PARITY_MODE_NONE|V_DUART_BITS_PER_CHAR_8,
+			     port->mode_1, i);
+		WRITE_SERCSR(M_DUART_STOP_BIT_LEN_1,
+			     port->mode_2, i);
+		WRITE_SERCSR(V_DUART_BAUD_RATE(115200),
+			     port->clk_sel, i);
+		WRITE_SERCSR(M_DUART_RX_EN|M_DUART_TX_EN,
+			     port->cmd, i);
+	}
 	return 0;
 }
 
 static struct console sb1250_ser_cons = {
-	name:		"ttyS",
+	name:		"duart",
 	write:		ser_console_write,
 	device:		ser_console_device,
 	setup:		ser_console_setup,
@@ -796,4 +930,4 @@
 	register_console(&sb1250_ser_cons);
 }
 
-#endif /* CONFIG_SERIAL_CONSOLE */
+#endif /* CONFIG_SIBYTE_SB1250_DUART_CONSOLE */
Index: drivers/char/sbc60xxwdt.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/sbc60xxwdt.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/sbc60xxwdt.c	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/sbc60xxwdt.c	4 Aug 2004 01:28:45 -0000	1.2
@@ -335,7 +335,7 @@
 	release_region(WDT_START,1);
 err_out_region1:
 	release_region(WDT_STOP,1);
-err_out:
+/* err_out: */
 	return rc;
 }
 
Index: drivers/char/scan_keyb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/scan_keyb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/scan_keyb.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/char/scan_keyb.c	4 Aug 2004 01:28:45 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *	$Id: scan_keyb.c,v 1.1 2004/07/22 19:49:50 joff Exp $ 
+ *	$Id: scan_keyb.c,v 1.2 2004/08/04 01:28:45 joff Exp $ 
  *	Copyright (C) 2000 YAEGASHI Takeshi
  *	Generic scan keyboard driver
  */
Index: drivers/char/scan_keyb.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/scan_keyb.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/scan_keyb.h	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/char/scan_keyb.h	4 Aug 2004 01:28:45 -0000	1.2
@@ -1,7 +1,7 @@
 #ifndef	__DRIVER_CHAR_SCAN_KEYB_H
 #define	__DRIVER_CHAR_SCAN_KEYB_H
 /*
- *	$Id: scan_keyb.h,v 1.1 2004/07/22 19:49:50 joff Exp $
+ *	$Id: scan_keyb.h,v 1.2 2004/08/04 01:28:45 joff Exp $
  *	Copyright (C) 2000 YAEGASHI Takeshi
  *	Generic scan keyboard driver
  */
Index: drivers/char/ser_a2232.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/ser_a2232.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/ser_a2232.c	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/ser_a2232.c	4 Aug 2004 01:28:45 -0000	1.2
@@ -1,6 +1,6 @@
 /* drivers/char/ser_a2232.c */
 
-/* $Id: ser_a2232.c,v 1.1 2004/07/22 19:49:52 joff Exp $ */
+/* $Id: ser_a2232.c,v 1.2 2004/08/04 01:28:45 joff Exp $ */
 
 /* Linux serial driver for the Amiga A2232 board */
 
@@ -776,7 +776,7 @@
 	volatile u_char *to;
 	volatile struct a2232memory *mem;
 
-#ifdef __SMP__
+#ifdef CONFIG_SMP
 	return -ENODEV;	/* This driver is not SMP aware. Is there an SMP ZorroII-bus-machine? */
 #endif
 
Index: drivers/char/ser_a2232.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/ser_a2232.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/ser_a2232.h	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/ser_a2232.h	4 Aug 2004 01:28:45 -0000	1.2
@@ -1,6 +1,6 @@
 /* drivers/char/ser_a2232.h */
 
-/* $Id: ser_a2232.h,v 1.1 2004/07/22 19:49:52 joff Exp $ */
+/* $Id: ser_a2232.h,v 1.2 2004/08/04 01:28:45 joff Exp $ */
 
 /* Linux serial driver for the Amiga A2232 board */
 
Index: drivers/char/ser_a2232fw.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/ser_a2232fw.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/ser_a2232fw.h	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/char/ser_a2232fw.h	4 Aug 2004 01:28:45 -0000	1.2
@@ -1,6 +1,6 @@
 /* drivers/char/ser_a2232fw.h */
 
-/* $Id: ser_a2232fw.h,v 1.1 2004/07/22 19:49:50 joff Exp $ */
+/* $Id: ser_a2232fw.h,v 1.2 2004/08/04 01:28:45 joff Exp $ */
 
 /*
  * Copyright (c) 1995 Jukka Marin <jmarin@jmp.fi>.
Index: drivers/char/serial.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/serial.c,v
retrieving revision 1.1
retrieving revision 1.7
diff -u -r1.1 -r1.7
--- drivers/char/serial.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/serial.c	20 Oct 2005 21:21:55 -0000	1.7
@@ -222,6 +222,7 @@
 #ifdef CONFIG_MAGIC_SYSRQ
 #include <linux/sysrq.h>
 #endif
+#include <linux/ts_sbc.h>
 
 /*
  * All of the compatibilty code so we can compile serial.c against
@@ -421,6 +422,15 @@
 		outb(info->hub6 - 1 + offset, info->port);
 		return inb(info->port+1);
 #endif
+	case SERIAL_IO_TS7KV:
+	{
+		int swin = inb(info->port + 0x1e);
+		int ret;
+		outb(0x0, info->port + 0x1e);
+		ret = inb(info->port + offset);
+		outb(swin, info->port + 0x1e);
+		return ret;
+	}
 	case SERIAL_IO_MEM:
 		return readb((unsigned long) info->iomem_base +
 			     (offset<<info->iomem_reg_shift));
@@ -439,6 +449,14 @@
 		outb(value, info->port+1);
 		break;
 #endif
+	case SERIAL_IO_TS7KV:
+	{
+		int swin = inb(info->port + 0x1e);
+		outb(0x0, info->port + 0x1e);
+		outb(value, info->port + offset);
+		outb(swin, info->port + 0x1e);
+		break;
+	}
 	case SERIAL_IO_MEM:
 		writeb(value, (unsigned long) info->iomem_base +
 			      (offset<<info->iomem_reg_shift));
@@ -914,10 +932,15 @@
 		if (status & UART_LSR_DR)
 			receive_chars(info, &status, regs);
 		check_modem_status(info);
+#ifdef CONFIG_MELAN
 		if ((status & UART_LSR_THRE) ||
 		    /* For buggy ELAN processors */
 		    ((iir & UART_IIR_ID) == UART_IIR_THRI))
 			transmit_chars(info, 0);
+#else
+		if (status & UART_LSR_THRE)
+			transmit_chars(info, 0);
+#endif
 		if (pass_counter++ > RS_ISR_PASS_LIMIT) {
 #if SERIAL_DEBUG_INTR
 			printk("rs_single loop break.\n");
@@ -2696,6 +2719,24 @@
 			/* "setserial -W" is called in Debian boot */
 			printk ("TIOCSER?WILD ioctl obsolete, ignored.\n");
 			return 0;
+		case TIOC_SBCC485:
+			if (info->io_type != SERIAL_IO_TS7KV)
+				return -EINVAL;
+
+			serial_out(info, 0x8, serial_in(info, 0x8) & ~0x1);
+			return 0;
+
+		case TIOC_SBCS485:
+			if (info->io_type != SERIAL_IO_TS7KV)
+				return -EINVAL;
+
+			if (arg & AUTO485FD) 
+				serial_out(info, 0x8, 0x3);
+
+			if (arg & AUTO485HD) 
+				serial_out(info, 0x8, 0x1);
+
+			return 0;
 
 		default:
 			return -ENOIOCTLCMD;
@@ -3741,7 +3782,14 @@
 		/* Check for Startech UART's */
 		serial_outp(info, UART_LCR, UART_LCR_DLAB);
 		if (serial_in(info, UART_EFR) == 0) {
+			serial_outp(info, UART_EFR, 0xA8);
+			if (serial_in(info, UART_EFR) == 0) {
+				/* We are a NS16552D/Motorola
+				 * 8xxx DUART, stop. */
+				goto out;
+			}
 			state->type = PORT_16650;
+			serial_outp(info, UART_EFR, 0);
 		} else {
 			serial_outp(info, UART_LCR, 0xBF);
 			if (serial_in(info, UART_EFR) == 0)
@@ -3790,6 +3838,7 @@
 		}
 	}
 #endif
+out:
 	serial_outp(info, UART_LCR, save_lcr);
 	if (state->type == PORT_16450) {
 		scratch = serial_in(info, UART_SCR);
@@ -4353,9 +4402,10 @@
 #ifdef CONFIG_DDB5074
 	pbn_nec_nile4,
 #endif
-#if 0
+
+	pbn_dci_pccom4,
 	pbn_dci_pccom8,
-#endif
+
 	pbn_xircom_combo,
 
 	pbn_siig10x_0,
@@ -4449,9 +4499,10 @@
 	{ SPCI_FL_BASE0, 1, 520833,			   /* pbn_nec_nile4 */
 		64, 3, NULL, 0x300 },
 #endif
-#if 0	/* PCI_DEVICE_ID_DCI_PCCOM8 ? */		   /* pbn_dci_pccom8 */
-	{ SPCI_FL_BASE3, 8, 115200, 8 },
-#endif
+
+	{SPCI_FL_BASE3, 4, 115200, 8},			   /* pbn_dci_pccom4 */
+	{SPCI_FL_BASE3, 8, 115200, 8},			   /* pbn_dci_pccom8 */
+
 	{ SPCI_FL_BASE0, 1, 115200,			  /* pbn_xircom_combo */
 		0, 0, pci_xircom_fn },
 
@@ -4920,11 +4971,12 @@
 		pbn_nec_nile4 },
 #endif
 
-#if 0	/* PCI_DEVICE_ID_DCI_PCCOM8 ? */
+	{	PCI_VENDOR_ID_DCI, PCI_DEVICE_ID_DCI_PCCOM4,
+		PCI_ANY_ID, PCI_ANY_ID, 0, 0,
+		pbn_dci_pccom4 },
 	{	PCI_VENDOR_ID_DCI, PCI_DEVICE_ID_DCI_PCCOM8,
 		PCI_ANY_ID, PCI_ANY_ID, 0, 0,
 		pbn_dci_pccom8 },
-#endif
 
        { PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID,
 	 PCI_CLASS_COMMUNICATION_SERIAL << 8, 0xffff00, },
Index: drivers/char/serial167.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/serial167.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/serial167.c	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/serial167.c	4 Aug 2004 01:28:45 -0000	1.2
@@ -9,7 +9,7 @@
  * ==============================================================
  *
  * static char rcsid[] =
- * "$Revision: 1.1 $$Date: 2004/07/22 19:49:52 $";
+ * "$Revision: 1.2 $$Date: 2004/08/04 01:28:45 $";
  *
  *  linux/kernel/cyclades.c
  *
@@ -28,8 +28,8 @@
  *   int  cy_open(struct tty_struct *tty, struct file *filp);
  *
  * $Log: serial167.c,v $
- * Revision 1.1  2004/07/22 19:49:52  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:28:45  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 1.36.1.4  1995/03/29  06:14:14  bentson
  * disambiguate between Cyclom-16Y and Cyclom-32Ye;
Index: drivers/char/serial9bit.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/serial9bit.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/char/serial9bit.c	12 Oct 2005 17:31:21 -0000	1.1
+++ drivers/char/serial9bit.c	1 Nov 2005 01:55:43 -0000	1.3
@@ -1,5 +1,5 @@
 /*
- *	9-bit serial port driver for Oxford 16550 UARTs.
+ * 9-bit serial port driver for Oxford 16550 UARTs.
  */
 
 #include <linux/module.h>
@@ -11,51 +11,498 @@
 #include <linux/miscdevice.h>
 #include <linux/reboot.h>
 #include <linux/init.h>
+#include <linux/time.h>
+#include <linux/slab.h>
+#include <linux/delay.h>
+#include <linux/ioport.h>
+#include <linux/interrupt.h>
+#include <linux/tqueue.h>
 #include <asm/uaccess.h>
 #include <asm/hardware.h>
 #include <asm/bitops.h>
+#include <asm/io.h>
 
+#include <asm-arm/arch-ep93xx/regmap.h>
 
-static int serial9bit_users;
-static int serial9bit_base;
+MODULE_AUTHOR("Ronald Gomes");
+MODULE_DESCRIPTION("9-bit serial driver for TS-SER1 PC104 board from Technologic Systems");
+MODULE_LICENSE("GPL");
+
+char *name="serial9bit";
+int io=-1;
+int irq=-1;
+
+MODULE_PARM(name, "1s");
+MODULE_PARM_DESC(name,"Name of the 9-bit serial /dev entry.");
+MODULE_PARM(io, "1i");
+MODULE_PARM_DESC(io,"IO address for 9-bit serial board");
+MODULE_PARM(irq, "1i");
+MODULE_PARM_DESC(irq,"IRQ line for 9-bit serial board");
+
+
+#define TSISA_BASE_IO	0x01E00000
+
+#define TSSER1_BASE_IO	0x02E8
+#define TSSER2_BASE_IO	0x03E8
+#define TSSER3_BASE_IO	0x03EA
+#define TSSER_SIZE_IO	0x8
+
+static int users;
+
+typedef struct serial9bit_dev {
+	char *name;
+	int io;
+	int irq;
+	unsigned long base_addr;
+	int bakACR;
+} serial9bit_dev;
+
+static struct serial9bit_dev *dev;
+
+DECLARE_WAIT_QUEUE_HEAD (rqueue);
+DECLARE_WAIT_QUEUE_HEAD (wqueue);
+
+#ifdef DECLARE_MUTEX
+static DECLARE_MUTEX(sem);
+#else
+static struct semaphore sem = MUTEX;
+#endif
+
+/*
+ * OX16C950 REGISTER DEFINES
+ */
+
+//Standard 550 Compatible Registers
+#define THR_OFFSET				0x00
+#define RHR_OFFSET				0x00
+#define IER_OFFSET				0x01
+#define FCR_OFFSET				0x02
+#define ISR_OFFSET				0x02
+#define LCR_OFFSET				0x03
+#define MCR_OFFSET				0x04
+#define LSR_OFFSET				0x05
+#define MSR_OFFSET				0x06
+#define SPR_OFFSET				0x07
+#define DLL_OFFSET				0x00
+#define DLM_OFFSET				0x01
+
+//650 Compatible Registers
+#define EFR_OFFSET				0x02
+#define XON1_OFFSET				0x04
+#define XON2_OFFSET				0x05
+#define XOFF1_OFFSET				0x06
+#define XOFF2_OFFSET				0x07
+
+//950 Specific Registers
+#define ASR_OFFSET				0x01
+#define RFL_OFFSET				0x03
+#define TFL_OFFSET				0x04
+#define ICR_OFFSET				0x05
+
+//Indexed Control Register Set
+#define ACR_INDEX					0x00
+#define CPR_INDEX					0x01
+#define TCR_INDEX					0x02
+#define CKS_INDEX					0x03
+#define TTL_INDEX					0x04
+#define RTL_INDEX					0x05
+#define FCL_INDEX					0x06
+#define FCH_INDEX					0x07
+#define ID1_INDEX					0x08
+#define ID2_INDEX					0x09
+#define ID3_INDEX					0x0A
+#define REV_INDEX					0x0B
+#define CSR_INDEX					0x0C
+#define NMR_INDEX					0x0D
+#define MDM_INDEX					0x0E
+#define RFC_INDEX					0x0F
+#define GDS_INDEX					0x10
+#define DMS_INDEX					0x11
+#define PIDX_INDEX				0x12
+#define CKA_INDEX					0x13
+
+//Misc - Bits
+#define RECEIVE_FIFO 			0x00
+#define TRANSMIT_FIFO 			0x01
+#define LCR_DL_ACCESS_KEY		0x80
+#define LCR_650_ACCESS_KEY		0xBF
+#define ACR_ICR_READ_EN	 		0x40
+#define FCR_FIFO_EN 				0x01
+#define EFR_ENHANCED_MODE_EN	0x10
+#define NMR_9BIT_MODE_EN		0x01
+#define NMR_9BIT_INTERRUPT_EN	0x02
+#define ACR_950_READ_EN			0x40
+#define LSR_DATA_AVAILABLE 	0x01
+#define LSR_FIFO_EMPTY			0x20
+
+//LSR error handler
+#define LSR_OVERRUN_ERROR 		0x02
+#define LSR_PARITY_ERROR 		0x04
+#define LSR_FRAMING_ERROR 		0x08
+#define LSR_BREAK 				0x10
+#define LSR_DATA_ERROR 			0x80
+#define LSR_ERROR_MASK 			(LSR_FRAMING_ERROR | LSR_BREAK | LSR_DATA_ERROR)
+
+//Baud Rate Divisor
+#define DIVISOR_BAUD_110 		0x0300
+#define DIVISOR_BAUD_300		0x0180
+#define DIVISOR_BAUD_600 		0x00C0
+#define DIVISOR_BAUD_1200 		0x0060
+#define DIVISOR_BAUD_2400 		0x0030
+#define DIVISOR_BAUD_4800 		0x0018
+#define DIVISOR_BAUD_9600 		0x000C
+#define DIVISOR_BAUD_19200 	0x0006
+#define DIVISOR_BAUD_28800 	0x0004
+#define DIVISOR_BAUD_38400 	0x0003
+#define DIVISOR_BAUD_57600 	0x0002
+#define DIVISOR_BAUD_115200 	0x0001
+
+//Interrupts
+#define IER_RX_INTERRUPT_EN 		0x01
+#define IER_TX_INTERRUPT_EN 		0x02
+#define IER_LSTAT_INTERRUPT_EN 	0x04
+#define IER_MSTAT_INTERRUPT_EN 	0x08
+#define IER_CHR_INTERRUPT_EN 		0x20
+#define IER_RTS_INTERRUPT_EN 		0x40
+#define IER_CTS_INTERRUPT_EN 		0x80
+
+//Type match
+#define FALSE	0
+#define TRUE	1
+
+//Functions declarations
+unsigned char readReg(serial9bit_dev *dev, unsigned char offset);
+void writeReg(serial9bit_dev *dev, unsigned char offset, unsigned char value);
+unsigned short readDivisor(serial9bit_dev *dev);
+void writeDivisor(serial9bit_dev *dev, unsigned short divisor);
+unsigned char read650(serial9bit_dev *dev, unsigned char offset);
+void write650(serial9bit_dev *dev, unsigned char offset, unsigned char value);
+unsigned char readASR(serial9bit_dev *dev);
+void writeASRBit(serial9bit_dev *dev, unsigned char bit, unsigned char value);
+unsigned char readICR(serial9bit_dev *dev, unsigned char index);
+void writeICR(serial9bit_dev *dev, unsigned char index, unsigned char value);
+unsigned char readFIFOLevel(serial9bit_dev *dev, unsigned char fifo);
+void lockAdditionalStatus(serial9bit_dev *dev);
+void unlockAdditionalStatus(serial9bit_dev *dev);
+
+
+/*
+ * Implementation section of basic functions
+ */
+
+//read-write basic routines for registers
+unsigned char readReg(serial9bit_dev *dev, unsigned char offset)
+{
+	return inb(dev->base_addr + offset);
+}
+
+void writeReg(serial9bit_dev *dev, unsigned char offset, unsigned char value)
+{
+	outb(value, dev->base_addr + offset);
+}
+
+//divisor latch word registers
+unsigned short readDivisor(serial9bit_dev *dev)
+{
+	unsigned short dlldlm;
+	unsigned char oldLCR;
+	oldLCR = readReg(dev, LCR_OFFSET);
+	writeReg(dev, LCR_OFFSET, oldLCR|LCR_DL_ACCESS_KEY);
+	dlldlm = (readReg(dev, DLM_OFFSET)<<8);
+	dlldlm += readReg(dev, DLL_OFFSET);
+	writeReg(dev, LCR_OFFSET, oldLCR);
+	return dlldlm;
+}
+
+void writeDivisor(serial9bit_dev *dev, unsigned short divisor)
+{
+	unsigned char oldLCR;
+	oldLCR = readReg(dev, LCR_OFFSET);
+	writeReg(dev, LCR_OFFSET, oldLCR|LCR_DL_ACCESS_KEY);
+	writeReg(dev, DLL_OFFSET, divisor&0x00FF );
+	writeReg(dev, DLM_OFFSET, (divisor&0xFF00)>>8 );
+	writeReg(dev, LCR_OFFSET, oldLCR);
+}
+
+//650 compatible registers.
+unsigned char read650(serial9bit_dev *dev, unsigned char offset)
+{
+	unsigned char result, oldLCR;
+	oldLCR = readReg(dev, LCR_OFFSET);
+	writeReg(dev, LCR_OFFSET, LCR_650_ACCESS_KEY);
+	result = readReg(dev, offset);
+	writeReg(dev, LCR_OFFSET, oldLCR);
+	return result;
+}
+
+void write650(serial9bit_dev *dev, unsigned char offset, unsigned char value)
+{
+	unsigned char oldLCR;
+	oldLCR = readReg(dev, LCR_OFFSET);
+	writeReg(dev, LCR_OFFSET, LCR_650_ACCESS_KEY);
+	writeReg(dev, offset, value);
+	writeReg(dev, LCR_OFFSET, oldLCR);
+}
+
+//950 compatible registers.
+unsigned char readASR(serial9bit_dev *dev)
+{
+	unsigned char retVal;
+	unlockAdditionalStatus(dev);
+	retVal = readReg(dev, ASR_OFFSET);
+	lockAdditionalStatus(dev);
+	return retVal;
+}
+
+void writeASRBit(serial9bit_dev *dev, unsigned char bit, unsigned char value)
+{
+	unsigned char currentASR;
+	if( bit!=0 && bit!=1 )
+		return
+	unlockAdditionalStatus(dev);
+	currentASR = readReg(dev, ASR_OFFSET);
+	if(value)
+		currentASR |= (1 << bit);
+	else
+		currentASR &= ~(1 << bit);
+	writeReg(dev, ASR_OFFSET, currentASR);
+	lockAdditionalStatus(dev);
+}
+
+//Reading FIFO Levels
+unsigned char readFIFOLevel(serial9bit_dev *dev, unsigned char fifo)
+{
+	unsigned char level1, offset;
+	if (fifo == RECEIVE_FIFO) offset = RFL_OFFSET;
+	else offset = TFL_OFFSET;
+	unlockAdditionalStatus(dev);
+	level1 = readReg(dev, offset);
+	lockAdditionalStatus(dev);
+	return level1;
+}
+
+//950 compatible registers.
+void lockAdditionalStatus(serial9bit_dev *dev)
+{
+	dev->bakACR &= ~ACR_950_READ_EN;
+	writeICR(dev, ACR_INDEX, dev->bakACR);
+}
+
+void unlockAdditionalStatus(serial9bit_dev *dev)
+{
+	dev->bakACR |= ACR_950_READ_EN;
+	writeICR(dev, ACR_INDEX, dev->bakACR);
+}
+
+unsigned char readICR(serial9bit_dev *dev, unsigned char index)
+{
+	unsigned char retVal;
+	writeICR(dev, ACR_INDEX, (unsigned char)(dev->bakACR|ACR_ICR_READ_EN));
+	writeReg(dev, SPR_OFFSET, index);
+	retVal = readReg(dev, ICR_OFFSET);
+	writeICR(dev, ACR_INDEX, (unsigned char)(dev->bakACR&~ACR_ICR_READ_EN));
+	return retVal;
+}
+
+void writeICR(serial9bit_dev *dev, unsigned char index, unsigned char value)
+{
+	writeReg(dev, SPR_OFFSET, index);
+	writeReg(dev, ICR_OFFSET, value);
+	if (index==ACR_INDEX)
+		dev->bakACR = value;
+}
+
+//Device Detection
+unsigned char detectOX16C95x(serial9bit_dev *dev)
+{
+	unsigned char id1, id2, id3, rev;
+	id1 = readICR(dev, ID1_INDEX);
+	id2 = readICR(dev, ID2_INDEX);
+	id3 = readICR(dev, ID3_INDEX);
+	rev = readICR(dev, REV_INDEX);
+	return ((id1==0x16)&&(id2==0xC9)&&((id3&0xF0)==0x50));
+}
+
+//Enable 9-bit mode
+void set9BitModeEnable(serial9bit_dev *dev, unsigned char state, unsigned char bit9int)
+{
+	unsigned char nmr = readICR(dev, NMR_INDEX);
+	if(state)
+		if(bit9int) nmr |= (NMR_9BIT_MODE_EN + NMR_9BIT_INTERRUPT_EN);
+		else nmr &=~(NMR_9BIT_INTERRUPT_EN);
+	else
+		nmr &= ~ NMR_9BIT_MODE_EN;
+	writeICR(dev, NMR_INDEX, nmr);
+}
+
+//Send 9-bit
+void send9BitData(serial9bit_dev *dev, unsigned short data)
+{
+	writeReg(dev, SPR_OFFSET, (data & 0x0100)>>8);
+	writeReg(dev, THR_OFFSET, data & 0x00FF);
+}
+
+//Receive 9-bit
+unsigned short receive9BitData(serial9bit_dev *dev)
+{
+	unsigned char lsr = readReg(dev, LSR_OFFSET);
+	unsigned short data = readReg(dev, RHR_OFFSET);
+	if(lsr & LSR_PARITY_ERROR) data |= 0x0100;
+	return data;
+}
+
+
+/*
+ * Implementation Section of linux device driver basic API functions
+ */
 
 static int serial9bit_open(struct inode *inode, struct file *file)
 {
-	if(test_and_set_bit(1,&serial9bit_users))
-		return -EBUSY;
+	//if(test_and_set_bit(1,&serial9bit_users))
+	//	return -EBUSY;
 	MOD_INC_USE_COUNT;
 	return 0;
 }
 
 static int serial9bit_release(struct inode *inode, struct file *file)
 {
-	serial9bit_users = 0;
+	//serial9bit_users = 0;
 	MOD_DEC_USE_COUNT;
 	return 0;
 }
 
-static ssize_t serial9bit_write(struct file *file, const char *data, size_t len, loff_t *ppos)
+static ssize_t serial9bit_write(struct file *filp, char *buf, size_t len, loff_t *offp)
 {
-	printk(KERN_INFO "Serial 9-bit driver write\n");
-	/*  Can't seek (pwrite) on this device  */
-	if (ppos != &file->f_pos)
+	int retval = len;
+	unsigned short *kbuf, *ptr;
+
+	if (offp != &filp->f_pos)
 		return -ESPIPE;
-	
-	/* Can't write odd number of bytes. (16-bit data expected) */
-	if (len & 0x1)
+
+	if (len&0x1)
 		return -EINVAL;
 
-	return 0;
+	if (down_interruptible(&sem))
+		return -ERESTARTSYS;
+
+	while ( (readReg(dev, LSR_OFFSET)&LSR_FIFO_EMPTY)==0 )
+	{
+		if (filp->f_flags & O_NONBLOCK)
+			return -EAGAIN;
+		up (&sem);
+		interruptible_sleep_on(&wqueue);
+		if (signal_pending (current))
+			return -ERESTARTSYS;
+		if (down_interruptible(&sem))
+			return -ERESTARTSYS;
+	}
+
+	kbuf=(unsigned short *)kmalloc(len, GFP_KERNEL);
+	if (!kbuf) {
+		retval = -ENOMEM;
+		goto err;
+	}
+	if (copy_from_user(kbuf, buf, len)) {
+		retval = -EFAULT;
+		goto err;
+	}
+	ptr=kbuf;
+
+	while (len) {
+		if (readFIFOLevel(dev, TRANSMIT_FIFO) == 128)
+			break;
+		send9BitData(dev, *(ptr++));
+		len-=2;
+	}
+
+	kfree(kbuf);
+	up (&sem);
+
+	return retval-len;
+
+	err:
+		kfree(kbuf);
+		up (&sem);
+		return retval;
 }
 
-static ssize_t serial9bit_read(struct file *filp, char * buf, size_t size, loff_t *offp)
+
+static ssize_t serial9bit_read(struct file *filp, char *buf, size_t len, loff_t *offp)
 {
-	printk(KERN_INFO "Serial 9-bit driver read\n");
-	/* Can't read odd number of bytes. (16-bit data) */
-	if (size & 0x1)
+	int retval=len, i=0;
+	unsigned short *kbuf, *ptr;
+	unsigned short lsr;
+
+	if (len&0x1)
 		return -EINVAL;
 
-	return 0;
+	if (down_interruptible(&sem))
+		return -ERESTARTSYS;
+
+	while ( (readReg(dev, LSR_OFFSET)&LSR_DATA_AVAILABLE)==0 )
+	{
+		writeReg(dev, IER_OFFSET, IER_RX_INTERRUPT_EN|IER_TX_INTERRUPT_EN);
+		up (&sem);
+		if (filp->f_flags & O_NONBLOCK)
+			return -EAGAIN;
+		interruptible_sleep_on(&rqueue);
+		if (signal_pending (current))
+			return -ERESTARTSYS;
+		if (down_interruptible(&sem))
+			return -ERESTARTSYS;
+	}
+
+	kbuf=(unsigned short *)kmalloc(len, GFP_KERNEL);
+	if (!kbuf) {
+		retval = -ENOMEM;
+		goto err;
+	}
+	ptr=kbuf;
+
+	while (len)
+	{
+		lsr = readReg(dev, LSR_OFFSET);
+
+		if (i==10) break;
+		if ( (lsr&LSR_DATA_AVAILABLE)==0 ) {
+			udelay(10);
+			i++;
+			continue;
+		}
+		i=0;
+
+		if ( (lsr&LSR_ERROR_MASK) )
+			break;
+
+		*(ptr++) = receive9BitData(dev);
+		len-=2;
+	}
+
+	if ( (retval > 0) && copy_to_user(buf, kbuf, retval-len)) {
+		retval = -EFAULT;
+		goto err;
+	}
+
+	kfree(kbuf);
+	up (&sem);
+
+	if ( (lsr&LSR_ERROR_MASK) ) {
+		printk(KERN_ERR "serial9bit: Read interrupted due ");
+		if (lsr&LSR_FRAMING_ERROR)
+			printk("framing ");
+		if (lsr&LSR_BREAK)
+			printk("break ");
+		if (lsr&LSR_DATA_ERROR)
+			printk("data ");
+		printk("error\n");
+	}
+
+	return retval-len;
+
+	err:
+		kfree(kbuf);
+		up (&sem);
+		return retval;
 }
 
 
@@ -68,17 +515,33 @@
 	}
 }
 
+static void int_handler(int irq, void *dev_id, struct pt_regs * regs)
+{
+	int isr = readReg(dev, ISR_OFFSET);
+	printk("serial9bit: interrupt handler 0x%x\n", isr);
+
+	if (isr&0x4) {
+		writeReg(dev, IER_OFFSET, IER_TX_INTERRUPT_EN);
+		wake_up_interruptible(&rqueue);
+	}
+
+	if (isr&0x2)
+		wake_up_interruptible(&rqueue);
+
+	return;
+}
+
 static struct file_operations serial9bit_fops=
 {
 	owner:		THIS_MODULE,
 	write:		serial9bit_write,
-	read:		serial9bit_read,
+	read:			serial9bit_read,
 	ioctl:		serial9bit_ioctl,
-	open:		serial9bit_open,
-	release:	serial9bit_release,
+	open:			serial9bit_open,
+	release:		serial9bit_release,
 };
 
-static struct miscdevice serial9bit_miscdev=
+struct miscdevice serial9bit_miscdev=
 {
 	MISC_DYNAMIC_MINOR,
 	"serial9bit",
@@ -87,13 +550,77 @@
 
 static int __init serial9bit_init(void)
 {
-	int ret;
-	printk(KERN_INFO "Serial 9-bit driver init\n");
+	int ret=0;
+	printk(KERN_INFO "serial9bit: Serial 9-bit driver init\n");
+
+	//IO module parameter check
+	if (io==-1 || irq==-1) {
+		printk(KERN_INFO "serial9bit: You must provide the IO address and IRQ line\n");
+		return -ENODEV;
+	}
+
+	dev = kmalloc(sizeof(serial9bit_dev), GFP_KERNEL);
+	if (!dev) {
+		printk(KERN_INFO "serial9bit: Error on memory allocation\n");
+		return -ENOMEM;
+	}
+	memset(dev, 0, sizeof(serial9bit_dev));
+
+	//Mapping IO base address
+	dev->name = name;
+	dev->io = io;
+	dev->irq = irq;
+	dev->base_addr = (unsigned long)TS7XXX_IOMEM + io;
+
+	if (check_mem_region(dev->base_addr, TSSER_SIZE_IO)) {
+		printk(KERN_INFO "serial9bit: Requested memory already in use\n");
+		kfree(dev);
+		return -ENOMEM;
+	}
+	request_mem_region(dev->base_addr, TSSER_SIZE_IO, dev->name);
 
-	ret = misc_register(&serial9bit_miscdev);
+	//Chip detection
+	{
+		//950 Mode selection
+		write650(dev, EFR_OFFSET, EFR_ENHANCED_MODE_EN);
+		writeReg(dev, FCR_OFFSET, FCR_FIFO_EN);
+		//9-bit chip detection test
+		if (!detectOX16C95x(dev)) {
+			printk(KERN_INFO "serial9bit: 9-bit chip NOT detected\n");
+			release_mem_region(dev->base_addr, TSSER_SIZE_IO);
+			kfree(dev);
+			return -ENODEV;
+		}
+	}
 
-	if (ret)
+	//Configuration for 9-Bit Mode
+	{
+		writeDivisor(dev, DIVISOR_BAUD_9600);
+		writeReg(dev, MCR_OFFSET, readReg(dev, MCR_OFFSET)&~0x10);
+		writeReg(dev, IER_OFFSET, IER_RX_INTERRUPT_EN|IER_TX_INTERRUPT_EN);
+		set9BitModeEnable(dev, TRUE, TRUE);
+	}
+
+	//Registering IRQ
+	if ((ret = request_irq(dev->irq, int_handler, SA_SHIRQ, dev->name, dev)) > 0) {
+		printk(KERN_INFO "serial9bit: Error on irq %i request\n", dev->irq);
+		release_mem_region(dev->base_addr, TSSER_SIZE_IO);
+		kfree(dev);
 		return ret;
+	}
+
+	//Registering the device + devfs
+	serial9bit_miscdev.name = name;
+	if ((ret = misc_register(&serial9bit_miscdev)) > 0) {
+		printk(KERN_INFO "serial9bit: Error on device registration\n");
+		free_irq(dev->irq, dev->name);
+		release_mem_region(dev->base_addr, TSSER_SIZE_IO);
+		kfree(dev);
+		return ret;
+	}
+
+	printk(KERN_INFO "serial9bit: Driver loaded with I/O address 0x%lx and IRQ %i\n",
+		dev->base_addr, dev->irq);
 
 	return 0;
 }
@@ -101,6 +628,10 @@
 static void __exit serial9bit_exit(void)
 {
 	misc_deregister(&serial9bit_miscdev);
+	free_irq(dev->irq, dev->name);
+	release_mem_region(dev->base_addr, TSSER_SIZE_IO);
+	kfree(dev);
+	printk(KERN_INFO "serial9bit: Driver unloaded\n");
 }
 
 module_init(serial9bit_init);
Index: drivers/char/serial_tx3912.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/serial_tx3912.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/serial_tx3912.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/char/serial_tx3912.c	4 Aug 2004 01:28:45 -0000	1.2
@@ -752,6 +752,21 @@
 	outl(int2, TX3912_INT2_ENABLE);
 }
 
+static int serial_console_wait_key(struct console *co)
+{
+	unsigned int int2, res;
+
+	int2 = inl(TX3912_INT2_ENABLE);
+	outl(0, TX3912_INT2_ENABLE);
+
+	while (!(inl(TX3912_UARTA_CTRL1) & TX3912_UART_CTRL1_RXHOLDFULL));
+	res = inl(TX3912_UARTA_DATA);
+	udelay(10);
+	
+	outl(int2, TX3912_INT2_ENABLE);
+	return res;
+}
+
 static void serial_console_write(struct console *co, const char *s,
 	unsigned count)
 {
